> For the complete documentation index, see [llms.txt](https://docs.flatredball.com/flatredball/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.flatredball.com/flatredball/api/flatredball/input/keyboard/getstringtyped.md).

# GetStringTyped

### Introduction

The Keyboard class can be used for text input. Unfortunately, at the time of this writing the keyboard only understands the English keyboard. The GetStringTyped method returns the string that was typed during the last frame. It is possible for multiple keys to be pressed during a frame and the GetStringTyped method also considers whether the Shift key is pressed.

### Code Example

The following code creates a Text object which displays the string typed.

Add the following using statement:

```
using FlatRedBall.Input;
using FlatRedBall.Graphics; // for Text
using Microsoft.Xna.Framework.Input; // for the Keys enum
```

in your Game class scope:

```
Text text;
```

Replace Initialize with the following:

```
protected override void Initialize()
{
    base.Initialize();     

    FlatRedBallServices.InitializeFlatRedBall(this, this.graphics);
    
    text = TextManager.AddText("Text:");
}

// Replace Update with the following:
protected override void Update(GameTime gameTime)
{
    FlatRedBallServices.Update(gameTime);

    text.DisplayText += InputManager.Keyboard.GetStringTyped();

    if (InputManager.Keyboard.KeyPushed(Keys.Enter))
        text.DisplayText = "";

    base.Update(gameTime);
}
```

![FlatRedBallIsTheBestText.png](https://951240982-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M_fye9Ufg3vzJxwX5Hk%2Fuploads%2Fgit-blob-84acb067c04f1cdc643761b6e7a53a24cd7518fa%2Fmigrated_media-FlatRedBallIsTheBestText.png?alt=media)

### Copy/Paste

GetStringTyped supports ctrl+c and ctrl+v for copy and paste; however, your game must be set to use \[STAThread]. For more information, see [this page](http://stackoverflow.com/questions/1361033/what-does-stathread-do).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.flatredball.com/flatredball/api/flatredball/input/keyboard/getstringtyped.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
